/*!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!*/
/* The source code in this module is proprietary software belonging to       */
/* Clark Development Company and is part of the PCBoard source code library. */
/* You are granted the right to use this source code for the building of any */
/* of the PCBoard products you have licensed.  Any other usage is forbidden  */
/* without prior written consent from Clark Development Company, Inc.        */
/*                                                                           */
/* Be sure to read the source code license agreement before utilizing any    */
/* of the source code found herein.                                          */
/*                                                                           */
/* Copyright (C) 1996  Clark Development Company, Inc.  All Rights Reserved. */
/*!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!*/


#include <string.h>
#include <stdio.h>
#include "misc.h"
#ifdef DEBUG
#include <memcheck.h>
#endif


void LIBENTRY makefilenameunique(char *NewName, char *Original) {
  int   X;
  char *p;

  strcpy(NewName,Original);
  if ((p = strrchr(NewName,'.')) == NULL)  /* point to the period */
    p = &NewName[strlen(NewName)];  /* or point to char after end of name */

  X = 0;
  while (1) {
    sprintf(p,".%03d",X++);
    if (fileexist(NewName) == 255) {
      if (rename(Original,NewName) == 0)
        break;
    }
  }
}
